# Models

## The AcknowledgeInstanceErrorsQueryModel object

```json
{"openapi":"3.0.1","info":{"title":"Frends API","version":"1.0"},"components":{"schemas":{"AcknowledgeInstanceErrorsQueryModel":{"required":["instanceIds","reason"],"type":"object","properties":{"reason":{"type":"string"},"instanceIds":{"type":"array","items":{"type":"integer","format":"int64"}}},"additionalProperties":false}}}}
```

## The AgentEventViewModel object

```json
{"openapi":"3.0.1","info":{"title":"Frends API","version":"1.0"},"components":{"schemas":{"AgentEventViewModel":{"type":"object","properties":{"id":{"type":"integer","format":"int64"},"eventId":{"type":"integer","format":"int64"},"level":{"type":"string"},"utcTimestamp":{"type":"string","format":"date-time"},"category":{"type":"integer","format":"int32"},"source":{"type":"string"},"message":{"type":"string"}},"additionalProperties":false}}}}
```

## The AgentEventViewModelPagedResponse object

```json
{"openapi":"3.0.1","info":{"title":"Frends API","version":"1.0"},"components":{"schemas":{"AgentEventViewModelPagedResponse":{"required":["Data","Paging"],"type":"object","properties":{"data":{"type":"array","items":{"$ref":"#/components/schemas/AgentEventViewModel"},"description":"Response data"},"paging":{"$ref":"#/components/schemas/PagingModel"}},"additionalProperties":false},"AgentEventViewModel":{"type":"object","properties":{"id":{"type":"integer","format":"int64"},"eventId":{"type":"integer","format":"int64"},"level":{"type":"string"},"utcTimestamp":{"type":"string","format":"date-time"},"category":{"type":"integer","format":"int32"},"source":{"type":"string"},"message":{"type":"string"}},"additionalProperties":false},"PagingModel":{"required":["CurrentPage","FirstPage","LastPage","PageSize","TotalCount"],"type":"object","properties":{"currentPage":{"type":"integer","description":"Current page","format":"int32"},"pageSize":{"type":"integer","description":"Number of entries per page","format":"int32"},"totalCount":{"type":"integer","description":"Total number of entries","format":"int32"},"firstPage":{"type":"string","description":"Url of the first page","format":"uri","nullable":true},"lastPage":{"type":"string","description":"Url of the last page","format":"uri","nullable":true},"nextPage":{"type":"string","description":"Url of the next page","format":"uri","nullable":true},"previousPage":{"type":"string","description":"Url of the previous page","format":"uri","nullable":true}},"additionalProperties":false}}}}
```

## The ApiAccessRuleType object

```json
{"openapi":"3.0.1","info":{"title":"Frends API","version":"1.0"},"components":{"schemas":{"ApiAccessRuleType":{"enum":["Allow","Deny"],"type":"string"}}}}
```

## The ApiKeyViewModel object

```json
{"openapi":"3.0.1","info":{"title":"Frends API","version":"1.0"},"components":{"schemas":{"ApiKeyViewModel":{"type":"object","properties":{"id":{"type":"integer","format":"int64"},"name":{"type":"string","nullable":true},"environment":{"type":"string","nullable":true},"value":{"type":"string","format":"uuid"}},"additionalProperties":false}}}}
```

## The ApiPassthroughCreateModel object

```json
{"openapi":"3.0.1","info":{"title":"Frends API","version":"1.0"},"components":{"schemas":{"ApiPassthroughCreateModel":{"type":"object","properties":{"corsEnabled":{"type":"boolean","description":"Is CORS enabled"},"targetUrl":{"$ref":"#/components/schemas/ApiPassthroughTarget"},"headers":{"type":"array","items":{"$ref":"#/components/schemas/ApiPassthroughHeader"},"description":"Header definitions","nullable":true},"allowedOrigins":{"type":"array","items":{"type":"string"},"description":"Allowed origins. Used when CORS is enabled.","nullable":true},"path":{"type":"string","description":"Source API path for this passthrough configuration. Not used when IsDefault is set to true.","nullable":true},"method":{"type":"string","description":"HTTP method. Not used when IsDefault is set to true.","nullable":true},"isDefault":{"type":"boolean","description":"Is this configuration used for all paths and HTTP methods"}},"additionalProperties":false},"ApiPassthroughTarget":{"type":"object","properties":{"server":{"type":"string","description":"Server part of the target URL"},"basePath":{"type":"string","description":"Base path of the target URL"},"operationPath":{"type":"string","description":"Operation path of the target URL","nullable":true},"query":{"type":"string","description":"Query parameters of the target URL","nullable":true}},"additionalProperties":false},"ApiPassthroughHeader":{"type":"object","properties":{"action":{"type":"string","description":"Header action (Add, Overwrite, Remove)"},"name":{"type":"string","description":"Header name"},"value":{"type":"string","description":"Header value"}},"additionalProperties":false}}}}
```

## The ApiPassthroughEditModel object

```json
{"openapi":"3.0.1","info":{"title":"Frends API","version":"1.0"},"components":{"schemas":{"ApiPassthroughEditModel":{"type":"object","properties":{"corsEnabled":{"type":"boolean","description":"Is CORS enabled"},"targetUrl":{"$ref":"#/components/schemas/ApiPassthroughTarget"},"headers":{"type":"array","items":{"$ref":"#/components/schemas/ApiPassthroughHeader"},"description":"Header definitions","nullable":true},"allowedOrigins":{"type":"array","items":{"type":"string"},"description":"Allowed origins. Used when CORS is enabled.","nullable":true}},"additionalProperties":false},"ApiPassthroughTarget":{"type":"object","properties":{"server":{"type":"string","description":"Server part of the target URL"},"basePath":{"type":"string","description":"Base path of the target URL"},"operationPath":{"type":"string","description":"Operation path of the target URL","nullable":true},"query":{"type":"string","description":"Query parameters of the target URL","nullable":true}},"additionalProperties":false},"ApiPassthroughHeader":{"type":"object","properties":{"action":{"type":"string","description":"Header action (Add, Overwrite, Remove)"},"name":{"type":"string","description":"Header name"},"value":{"type":"string","description":"Header value"}},"additionalProperties":false}}}}
```

## The ApiPassthroughHeader object

```json
{"openapi":"3.0.1","info":{"title":"Frends API","version":"1.0"},"components":{"schemas":{"ApiPassthroughHeader":{"type":"object","properties":{"action":{"type":"string","description":"Header action (Add, Overwrite, Remove)"},"name":{"type":"string","description":"Header name"},"value":{"type":"string","description":"Header value"}},"additionalProperties":false}}}}
```

## The ApiPassthroughTarget object

```json
{"openapi":"3.0.1","info":{"title":"Frends API","version":"1.0"},"components":{"schemas":{"ApiPassthroughTarget":{"type":"object","properties":{"server":{"type":"string","description":"Server part of the target URL"},"basePath":{"type":"string","description":"Base path of the target URL"},"operationPath":{"type":"string","description":"Operation path of the target URL","nullable":true},"query":{"type":"string","description":"Query parameters of the target URL","nullable":true}},"additionalProperties":false}}}}
```

## The ApiPassthroughViewModel object

```json
{"openapi":"3.0.1","info":{"title":"Frends API","version":"1.0"},"components":{"schemas":{"ApiPassthroughViewModel":{"type":"object","properties":{"id":{"type":"integer","description":"Unique identifier of the passthrough configuration","format":"int64"},"apiVersionId":{"type":"integer","description":"Unique identifier of the API version","format":"int64"},"modifier":{"type":"string","description":"User who last modified the configuration"},"modified":{"type":"string","description":"Time when configuration was last modified","format":"date-time"},"path":{"type":"string","description":"Source API path for this passthrough configuration. Not used when IsDefault is set to true.","nullable":true},"method":{"type":"string","description":"HTTP method. Not used when IsDefault is set to true.","nullable":true},"isDefault":{"type":"boolean","description":"Is this configuration used for all paths and HTTP methods"},"corsEnabled":{"type":"boolean","description":"Is CORS enabled"},"targetUrl":{"$ref":"#/components/schemas/ApiPassthroughTarget"},"headers":{"type":"array","items":{"$ref":"#/components/schemas/ApiPassthroughHeader"},"description":"Header definitions","nullable":true},"allowedOrigins":{"type":"array","items":{"type":"string"},"description":"Allowed origins. Used when CORS is enabled.","nullable":true}},"additionalProperties":false},"ApiPassthroughTarget":{"type":"object","properties":{"server":{"type":"string","description":"Server part of the target URL"},"basePath":{"type":"string","description":"Base path of the target URL"},"operationPath":{"type":"string","description":"Operation path of the target URL","nullable":true},"query":{"type":"string","description":"Query parameters of the target URL","nullable":true}},"additionalProperties":false},"ApiPassthroughHeader":{"type":"object","properties":{"action":{"type":"string","description":"Header action (Add, Overwrite, Remove)"},"name":{"type":"string","description":"Header name"},"value":{"type":"string","description":"Header value"}},"additionalProperties":false}}}}
```

## The ApiPassthroughViewModelIListResponse object

```json
{"openapi":"3.0.1","info":{"title":"Frends API","version":"1.0"},"components":{"schemas":{"ApiPassthroughViewModelIListResponse":{"required":["Data"],"type":"object","properties":{"data":{"type":"array","items":{"$ref":"#/components/schemas/ApiPassthroughViewModel"},"description":"Response data","nullable":true}},"additionalProperties":false},"ApiPassthroughViewModel":{"type":"object","properties":{"id":{"type":"integer","description":"Unique identifier of the passthrough configuration","format":"int64"},"apiVersionId":{"type":"integer","description":"Unique identifier of the API version","format":"int64"},"modifier":{"type":"string","description":"User who last modified the configuration"},"modified":{"type":"string","description":"Time when configuration was last modified","format":"date-time"},"path":{"type":"string","description":"Source API path for this passthrough configuration. Not used when IsDefault is set to true.","nullable":true},"method":{"type":"string","description":"HTTP method. Not used when IsDefault is set to true.","nullable":true},"isDefault":{"type":"boolean","description":"Is this configuration used for all paths and HTTP methods"},"corsEnabled":{"type":"boolean","description":"Is CORS enabled"},"targetUrl":{"$ref":"#/components/schemas/ApiPassthroughTarget"},"headers":{"type":"array","items":{"$ref":"#/components/schemas/ApiPassthroughHeader"},"description":"Header definitions","nullable":true},"allowedOrigins":{"type":"array","items":{"type":"string"},"description":"Allowed origins. Used when CORS is enabled.","nullable":true}},"additionalProperties":false},"ApiPassthroughTarget":{"type":"object","properties":{"server":{"type":"string","description":"Server part of the target URL"},"basePath":{"type":"string","description":"Base path of the target URL"},"operationPath":{"type":"string","description":"Operation path of the target URL","nullable":true},"query":{"type":"string","description":"Query parameters of the target URL","nullable":true}},"additionalProperties":false},"ApiPassthroughHeader":{"type":"object","properties":{"action":{"type":"string","description":"Header action (Add, Overwrite, Remove)"},"name":{"type":"string","description":"Header name"},"value":{"type":"string","description":"Header value"}},"additionalProperties":false}}}}
```

## The ApiPassthroughViewModelResponse object

```json
{"openapi":"3.0.1","info":{"title":"Frends API","version":"1.0"},"components":{"schemas":{"ApiPassthroughViewModelResponse":{"required":["Data"],"type":"object","properties":{"data":{"$ref":"#/components/schemas/ApiPassthroughViewModel"}},"additionalProperties":false},"ApiPassthroughViewModel":{"type":"object","properties":{"id":{"type":"integer","description":"Unique identifier of the passthrough configuration","format":"int64"},"apiVersionId":{"type":"integer","description":"Unique identifier of the API version","format":"int64"},"modifier":{"type":"string","description":"User who last modified the configuration"},"modified":{"type":"string","description":"Time when configuration was last modified","format":"date-time"},"path":{"type":"string","description":"Source API path for this passthrough configuration. Not used when IsDefault is set to true.","nullable":true},"method":{"type":"string","description":"HTTP method. Not used when IsDefault is set to true.","nullable":true},"isDefault":{"type":"boolean","description":"Is this configuration used for all paths and HTTP methods"},"corsEnabled":{"type":"boolean","description":"Is CORS enabled"},"targetUrl":{"$ref":"#/components/schemas/ApiPassthroughTarget"},"headers":{"type":"array","items":{"$ref":"#/components/schemas/ApiPassthroughHeader"},"description":"Header definitions","nullable":true},"allowedOrigins":{"type":"array","items":{"type":"string"},"description":"Allowed origins. Used when CORS is enabled.","nullable":true}},"additionalProperties":false},"ApiPassthroughTarget":{"type":"object","properties":{"server":{"type":"string","description":"Server part of the target URL"},"basePath":{"type":"string","description":"Base path of the target URL"},"operationPath":{"type":"string","description":"Operation path of the target URL","nullable":true},"query":{"type":"string","description":"Query parameters of the target URL","nullable":true}},"additionalProperties":false},"ApiPassthroughHeader":{"type":"object","properties":{"action":{"type":"string","description":"Header action (Add, Overwrite, Remove)"},"name":{"type":"string","description":"Header name"},"value":{"type":"string","description":"Header value"}},"additionalProperties":false}}}}
```

## The ApiPolicyApiKeyGroupAssignmentSaveModel object

```json
{"openapi":"3.0.1","info":{"title":"Frends API","version":"1.0"},"components":{"schemas":{"ApiPolicyApiKeyGroupAssignmentSaveModel":{"required":["apiKey"],"type":"object","properties":{"apiKey":{"$ref":"#/components/schemas/ApiPolicyApiKeySaveModel"}},"additionalProperties":false},"ApiPolicyApiKeySaveModel":{"type":"object","properties":{"id":{"type":"integer","description":"The API key identifier","format":"int64"}},"additionalProperties":false}}}}
```

## The ApiPolicyApiKeyGroupAssignmentViewModel object

```json
{"openapi":"3.0.1","info":{"title":"Frends API","version":"1.0"},"components":{"schemas":{"ApiPolicyApiKeyGroupAssignmentViewModel":{"required":["apiKey"],"type":"object","properties":{"id":{"type":"integer","description":"The identifier of the assignment","format":"int64"},"apiKey":{"$ref":"#/components/schemas/ApiKeyViewModel"}},"additionalProperties":false},"ApiKeyViewModel":{"type":"object","properties":{"id":{"type":"integer","format":"int64"},"name":{"type":"string","nullable":true},"environment":{"type":"string","nullable":true},"value":{"type":"string","format":"uuid"}},"additionalProperties":false}}}}
```

## The ApiPolicyApiKeyGroupSaveModel object

```json
{"openapi":"3.0.1","info":{"title":"Frends API","version":"1.0"},"components":{"schemas":{"ApiPolicyApiKeyGroupSaveModel":{"required":["apiPolicyApiKeyGroupAssignments","name"],"type":"object","properties":{"requestLimit":{"type":"integer","description":"The maximum amount of requests. Not null value requires RequestLimitWindowInMinutes to be set.","format":"int32","nullable":true},"requestLimitWindowInMinutes":{"type":"integer","description":"The request limit window in minutes. Not null value requires RequestLimit to be set.","format":"int32","nullable":true},"name":{"type":"string","description":"The name of the API key group"},"apiPolicyApiKeyGroupAssignments":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyApiKeyGroupAssignmentSaveModel"},"description":"The API key group assignments"}},"additionalProperties":false},"ApiPolicyApiKeyGroupAssignmentSaveModel":{"required":["apiKey"],"type":"object","properties":{"apiKey":{"$ref":"#/components/schemas/ApiPolicyApiKeySaveModel"}},"additionalProperties":false},"ApiPolicyApiKeySaveModel":{"type":"object","properties":{"id":{"type":"integer","description":"The API key identifier","format":"int64"}},"additionalProperties":false}}}}
```

## The ApiPolicyApiKeyGroupViewModel object

```json
{"openapi":"3.0.1","info":{"title":"Frends API","version":"1.0"},"components":{"schemas":{"ApiPolicyApiKeyGroupViewModel":{"required":["name"],"type":"object","properties":{"requestLimit":{"type":"integer","description":"The maximum amount of requests. Not null value requires RequestLimitWindowInMinutes to be set.","format":"int32","nullable":true},"requestLimitWindowInMinutes":{"type":"integer","description":"The request limit window in minutes. Not null value requires RequestLimit to be set.","format":"int32","nullable":true},"name":{"type":"string","description":"The name of the API key group"},"id":{"type":"integer","description":"The unique identifier of the API key group","format":"int64","readOnly":true},"apiPolicyApiKeyGroupAssignments":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyApiKeyGroupAssignmentViewModel"},"description":"The API group assignments","readOnly":true}},"additionalProperties":false},"ApiPolicyApiKeyGroupAssignmentViewModel":{"required":["apiKey"],"type":"object","properties":{"id":{"type":"integer","description":"The identifier of the assignment","format":"int64"},"apiKey":{"$ref":"#/components/schemas/ApiKeyViewModel"}},"additionalProperties":false},"ApiKeyViewModel":{"type":"object","properties":{"id":{"type":"integer","format":"int64"},"name":{"type":"string","nullable":true},"environment":{"type":"string","nullable":true},"value":{"type":"string","format":"uuid"}},"additionalProperties":false}}}}
```

## The ApiPolicyApiKeySaveModel object

```json
{"openapi":"3.0.1","info":{"title":"Frends API","version":"1.0"},"components":{"schemas":{"ApiPolicyApiKeySaveModel":{"type":"object","properties":{"id":{"type":"integer","description":"The API key identifier","format":"int64"}},"additionalProperties":false}}}}
```

## The ApiPolicyDeploymentSaveModel object

```json
{"openapi":"3.0.1","info":{"title":"Frends API","version":"1.0"},"components":{"schemas":{"ApiPolicyDeploymentSaveModel":{"required":["agentGroupName"],"type":"object","properties":{"agentGroupName":{"type":"string","description":"The Agent Group associated with the deployment"}},"additionalProperties":false}}}}
```

## The ApiPolicyDeploymentViewModel object

```json
{"openapi":"3.0.1","info":{"title":"Frends API","version":"1.0"},"components":{"schemas":{"ApiPolicyDeploymentViewModel":{"required":["agentGroupName"],"type":"object","properties":{"agentGroupName":{"type":"string","description":"The Agent Group associated with the deployment"},"id":{"type":"integer","description":"The unique identifier of the deployment","format":"int64","readOnly":true},"deployerUserName":{"type":"string","description":"The username of the deployer"},"deployedUtc":{"type":"string","description":"The timestamp when the deployment occurred","format":"date-time"}},"additionalProperties":false}}}}
```

## The ApiPolicyIdentityRuleSaveModel object

```json
{"openapi":"3.0.1","info":{"title":"Frends API","version":"1.0"},"components":{"schemas":{"ApiPolicyIdentityRuleSaveModel":{"required":["claim"],"type":"object","properties":{"ruleType":{"$ref":"#/components/schemas/ApiAccessRuleType"},"claim":{"type":"string","description":"The claim associated with the identity rule"},"value":{"type":"string","description":"The value associated with the identity rule","nullable":true},"matchType":{"$ref":"#/components/schemas/IdentityRuleMatchType"}},"additionalProperties":false},"ApiAccessRuleType":{"enum":["Allow","Deny"],"type":"string"},"IdentityRuleMatchType":{"enum":["Exact","Exists","Regex"],"type":"string"}}}}
```

## The ApiPolicyIdentityRuleViewModel object

```json
{"openapi":"3.0.1","info":{"title":"Frends API","version":"1.0"},"components":{"schemas":{"ApiPolicyIdentityRuleViewModel":{"type":"object","properties":{"id":{"type":"integer","description":"The unique identifier of the identity rule","format":"int64","readOnly":true},"ruleType":{"$ref":"#/components/schemas/ApiAccessRuleType"},"claim":{"type":"string","description":"The claim associated with the identity rule","readOnly":true},"value":{"type":"string","description":"The value associated with the identity rule","readOnly":true},"matchType":{"$ref":"#/components/schemas/IdentityRuleMatchType"}},"additionalProperties":false},"ApiAccessRuleType":{"enum":["Allow","Deny"],"type":"string"},"IdentityRuleMatchType":{"enum":["Exact","Exists","Regex"],"type":"string"}}}}
```

## The ApiPolicyIdentitySaveModel object

```json
{"openapi":"3.0.1","info":{"title":"Frends API","version":"1.0"},"components":{"schemas":{"ApiPolicyIdentitySaveModel":{"required":["deployments","issuers","name"],"type":"object","properties":{"requestLimit":{"type":"integer","description":"The maximum amount of requests. Not null value requires RequestLimitWindowInMinutes to be set.","format":"int32","nullable":true},"requestLimitWindowInMinutes":{"type":"integer","description":"The request limit window in minutes. Not null value requires RequestLimit to be set.","format":"int32","nullable":true},"isPrivateApplication":{"type":"boolean","description":"Determines if it is a private application"},"issuers":{"type":"array","items":{"type":"string"},"description":"The issuers of the identity"},"name":{"type":"string","description":"The name of the identity"},"throttlingByClaim":{"type":"string","description":"The throttling by claim for the identity","nullable":true},"priorityNumber":{"type":"integer","description":"In case of 2 or more matching identities, determines which identity to use. Lower number will be selected.","format":"int32"},"id":{"type":"integer","description":"The unique identifier of the identity. Only provide a value when updating.","format":"int64","nullable":true},"identityRules":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyIdentityRuleSaveModel"},"description":"The list of identity rules","nullable":true},"deployments":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyDeploymentSaveModel"},"description":"The list of deployments associated with the identity"}},"additionalProperties":false},"ApiPolicyIdentityRuleSaveModel":{"required":["claim"],"type":"object","properties":{"ruleType":{"$ref":"#/components/schemas/ApiAccessRuleType"},"claim":{"type":"string","description":"The claim associated with the identity rule"},"value":{"type":"string","description":"The value associated with the identity rule","nullable":true},"matchType":{"$ref":"#/components/schemas/IdentityRuleMatchType"}},"additionalProperties":false},"ApiAccessRuleType":{"enum":["Allow","Deny"],"type":"string"},"IdentityRuleMatchType":{"enum":["Exact","Exists","Regex"],"type":"string"},"ApiPolicyDeploymentSaveModel":{"required":["agentGroupName"],"type":"object","properties":{"agentGroupName":{"type":"string","description":"The Agent Group associated with the deployment"}},"additionalProperties":false}}}}
```

## The ApiPolicyIdentityViewModel object

```json
{"openapi":"3.0.1","info":{"title":"Frends API","version":"1.0"},"components":{"schemas":{"ApiPolicyIdentityViewModel":{"required":["issuers","name"],"type":"object","properties":{"requestLimit":{"type":"integer","description":"The maximum amount of requests. Not null value requires RequestLimitWindowInMinutes to be set.","format":"int32","nullable":true},"requestLimitWindowInMinutes":{"type":"integer","description":"The request limit window in minutes. Not null value requires RequestLimit to be set.","format":"int32","nullable":true},"isPrivateApplication":{"type":"boolean","description":"Determines if it is a private application"},"issuers":{"type":"array","items":{"type":"string"},"description":"The issuers of the identity"},"name":{"type":"string","description":"The name of the identity"},"throttlingByClaim":{"type":"string","description":"The throttling by claim for the identity","nullable":true},"priorityNumber":{"type":"integer","description":"In case of 2 or more matching identities, determines which identity to use. Lower number will be selected.","format":"int32"},"id":{"type":"integer","description":"The unique identifier of the identity","format":"int64","readOnly":true},"identityRules":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyIdentityRuleViewModel"}},"deployments":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyDeploymentViewModel"},"description":"The list of deployments associated with the identity"}},"additionalProperties":false},"ApiPolicyIdentityRuleViewModel":{"type":"object","properties":{"id":{"type":"integer","description":"The unique identifier of the identity rule","format":"int64","readOnly":true},"ruleType":{"$ref":"#/components/schemas/ApiAccessRuleType"},"claim":{"type":"string","description":"The claim associated with the identity rule","readOnly":true},"value":{"type":"string","description":"The value associated with the identity rule","readOnly":true},"matchType":{"$ref":"#/components/schemas/IdentityRuleMatchType"}},"additionalProperties":false},"ApiAccessRuleType":{"enum":["Allow","Deny"],"type":"string"},"IdentityRuleMatchType":{"enum":["Exact","Exists","Regex"],"type":"string"},"ApiPolicyDeploymentViewModel":{"required":["agentGroupName"],"type":"object","properties":{"agentGroupName":{"type":"string","description":"The Agent Group associated with the deployment"},"id":{"type":"integer","description":"The unique identifier of the deployment","format":"int64","readOnly":true},"deployerUserName":{"type":"string","description":"The username of the deployer"},"deployedUtc":{"type":"string","description":"The timestamp when the deployment occurred","format":"date-time"}},"additionalProperties":false}}}}
```

## The ApiPolicyListItemViewModel object

```json
{"openapi":"3.0.1","info":{"title":"Frends API","version":"1.0"},"components":{"schemas":{"ApiPolicyListItemViewModel":{"type":"object","properties":{"id":{"type":"integer","description":"The unique identifier of the API policy","format":"int64","readOnly":true},"name":{"type":"string","description":"The name of the policy"},"description":{"type":"string","description":"The description of the policy","nullable":true}},"additionalProperties":false}}}}
```

## The ApiPolicyListItemViewModelIEnumerableResponse object

```json
{"openapi":"3.0.1","info":{"title":"Frends API","version":"1.0"},"components":{"schemas":{"ApiPolicyListItemViewModelIEnumerableResponse":{"required":["Data"],"type":"object","properties":{"data":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyListItemViewModel"},"description":"Response data","nullable":true}},"additionalProperties":false},"ApiPolicyListItemViewModel":{"type":"object","properties":{"id":{"type":"integer","description":"The unique identifier of the API policy","format":"int64","readOnly":true},"name":{"type":"string","description":"The name of the policy"},"description":{"type":"string","description":"The description of the policy","nullable":true}},"additionalProperties":false}}}}
```

## The ApiPolicyRequestLoggingSaveModel object

```json
{"openapi":"3.0.1","info":{"title":"Frends API","version":"1.0"},"components":{"schemas":{"ApiPolicyRequestLoggingSaveModel":{"required":["deployments","loggingFields","name"],"type":"object","properties":{"name":{"type":"string","description":"The name of the request logging"},"loggingFields":{"type":"array","items":{"type":"string"},"description":"The fields logged by request logging"},"ipLogging":{"$ref":"#/components/schemas/IpLoggingType"},"requestBodyMaxLengthKb":{"type":"integer","description":"Request body maximum length for request logging","format":"int32"},"responseBodyMaxLengthKb":{"type":"integer","description":"Response body maximum length for request logging","format":"int32"},"disableLogging":{"type":"boolean","description":"Disable logging for request logging"},"id":{"type":"integer","description":"The unique identifier of the request logging. Only provide a value when updating.","format":"int64","nullable":true},"deployments":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyDeploymentSaveModel"},"description":"The list of deployments associated with the request logging"}},"additionalProperties":false},"IpLoggingType":{"enum":["ClientIP","ClientIPXForwardedForFirst","ClientIPXForwardedForAll","Disable"],"type":"string"},"ApiPolicyDeploymentSaveModel":{"required":["agentGroupName"],"type":"object","properties":{"agentGroupName":{"type":"string","description":"The Agent Group associated with the deployment"}},"additionalProperties":false}}}}
```

## The ApiPolicyRequestLoggingViewModel object

```json
{"openapi":"3.0.1","info":{"title":"Frends API","version":"1.0"},"components":{"schemas":{"ApiPolicyRequestLoggingViewModel":{"required":["loggingFields","name"],"type":"object","properties":{"name":{"type":"string","description":"The name of the request logging"},"loggingFields":{"type":"array","items":{"type":"string"},"description":"The fields logged by request logging"},"ipLogging":{"$ref":"#/components/schemas/IpLoggingType"},"requestBodyMaxLengthKb":{"type":"integer","description":"Request body maximum length for request logging","format":"int32"},"responseBodyMaxLengthKb":{"type":"integer","description":"Response body maximum length for request logging","format":"int32"},"disableLogging":{"type":"boolean","description":"Disable logging for request logging"},"id":{"type":"integer","description":"The unique identifier of the request logging","format":"int64","readOnly":true},"deployments":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyDeploymentViewModel"},"description":"The list of deployments associated with the request logging"}},"additionalProperties":false},"IpLoggingType":{"enum":["ClientIP","ClientIPXForwardedForFirst","ClientIPXForwardedForAll","Disable"],"type":"string"},"ApiPolicyDeploymentViewModel":{"required":["agentGroupName"],"type":"object","properties":{"agentGroupName":{"type":"string","description":"The Agent Group associated with the deployment"},"id":{"type":"integer","description":"The unique identifier of the deployment","format":"int64","readOnly":true},"deployerUserName":{"type":"string","description":"The username of the deployer"},"deployedUtc":{"type":"string","description":"The timestamp when the deployment occurred","format":"date-time"}},"additionalProperties":false}}}}
```

## The ApiPolicySaveModel object

```json
{"openapi":"3.0.1","info":{"title":"Frends API","version":"1.0"},"components":{"schemas":{"ApiPolicySaveModel":{"required":["name","targetEndpoints"],"type":"object","properties":{"name":{"type":"string","description":"The name of the policy"},"description":{"type":"string","description":"The description of the policy","nullable":true},"tags":{"type":"array","items":{"type":"string"},"description":"The tags of the policy","nullable":true},"allowPublicAccess":{"type":"boolean","description":"Determines if public access is allowed"},"apiKeyName":{"type":"string","description":"The name of the API key"},"apiKeyLocation":{"$ref":"#/components/schemas/ParameterLocation"},"targetEndpoints":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyTargetEndpointSaveModel"},"description":"The list of target endpoints associated with the policy"},"identities":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyIdentitySaveModel"},"description":"The list of identities associated with the policy","nullable":true},"apiKeyGroups":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyApiKeyGroupSaveModel"},"description":"The list of API key groups associated with the policy","nullable":true},"publicAccessDeployments":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyDeploymentSaveModel"},"description":"The list of deployments associated with the public access identity","nullable":true},"requestLoggingOptions":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyRequestLoggingSaveModel"},"description":"The list of request logging options associated with the api policy","nullable":true}},"additionalProperties":false},"ParameterLocation":{"enum":["Query","Header","Path","Cookie"],"type":"string"},"ApiPolicyTargetEndpointSaveModel":{"required":["path"],"type":"object","properties":{"requestLimit":{"type":"integer","description":"The maximum amount of requests. Not null value requires RequestLimitWindowInMinutes to be set.","format":"int32","nullable":true},"requestLimitWindowInMinutes":{"type":"integer","description":"The request limit window in minutes. Not null value requires RequestLimit to be set.","format":"int32","nullable":true},"path":{"type":"string","description":"The path of the target endpoint"},"method":{"$ref":"#/components/schemas/PolicyEndpointMethod"}},"additionalProperties":false},"PolicyEndpointMethod":{"enum":["All","Get","Post","Put","Head","Delete","Patch","Options","Connect","Trace"],"type":"string"},"ApiPolicyIdentitySaveModel":{"required":["deployments","issuers","name"],"type":"object","properties":{"requestLimit":{"type":"integer","description":"The maximum amount of requests. Not null value requires RequestLimitWindowInMinutes to be set.","format":"int32","nullable":true},"requestLimitWindowInMinutes":{"type":"integer","description":"The request limit window in minutes. Not null value requires RequestLimit to be set.","format":"int32","nullable":true},"isPrivateApplication":{"type":"boolean","description":"Determines if it is a private application"},"issuers":{"type":"array","items":{"type":"string"},"description":"The issuers of the identity"},"name":{"type":"string","description":"The name of the identity"},"throttlingByClaim":{"type":"string","description":"The throttling by claim for the identity","nullable":true},"priorityNumber":{"type":"integer","description":"In case of 2 or more matching identities, determines which identity to use. Lower number will be selected.","format":"int32"},"id":{"type":"integer","description":"The unique identifier of the identity. Only provide a value when updating.","format":"int64","nullable":true},"identityRules":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyIdentityRuleSaveModel"},"description":"The list of identity rules","nullable":true},"deployments":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyDeploymentSaveModel"},"description":"The list of deployments associated with the identity"}},"additionalProperties":false},"ApiPolicyIdentityRuleSaveModel":{"required":["claim"],"type":"object","properties":{"ruleType":{"$ref":"#/components/schemas/ApiAccessRuleType"},"claim":{"type":"string","description":"The claim associated with the identity rule"},"value":{"type":"string","description":"The value associated with the identity rule","nullable":true},"matchType":{"$ref":"#/components/schemas/IdentityRuleMatchType"}},"additionalProperties":false},"ApiAccessRuleType":{"enum":["Allow","Deny"],"type":"string"},"IdentityRuleMatchType":{"enum":["Exact","Exists","Regex"],"type":"string"},"ApiPolicyDeploymentSaveModel":{"required":["agentGroupName"],"type":"object","properties":{"agentGroupName":{"type":"string","description":"The Agent Group associated with the deployment"}},"additionalProperties":false},"ApiPolicyApiKeyGroupSaveModel":{"required":["apiPolicyApiKeyGroupAssignments","name"],"type":"object","properties":{"requestLimit":{"type":"integer","description":"The maximum amount of requests. Not null value requires RequestLimitWindowInMinutes to be set.","format":"int32","nullable":true},"requestLimitWindowInMinutes":{"type":"integer","description":"The request limit window in minutes. Not null value requires RequestLimit to be set.","format":"int32","nullable":true},"name":{"type":"string","description":"The name of the API key group"},"apiPolicyApiKeyGroupAssignments":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyApiKeyGroupAssignmentSaveModel"},"description":"The API key group assignments"}},"additionalProperties":false},"ApiPolicyApiKeyGroupAssignmentSaveModel":{"required":["apiKey"],"type":"object","properties":{"apiKey":{"$ref":"#/components/schemas/ApiPolicyApiKeySaveModel"}},"additionalProperties":false},"ApiPolicyApiKeySaveModel":{"type":"object","properties":{"id":{"type":"integer","description":"The API key identifier","format":"int64"}},"additionalProperties":false},"ApiPolicyRequestLoggingSaveModel":{"required":["deployments","loggingFields","name"],"type":"object","properties":{"name":{"type":"string","description":"The name of the request logging"},"loggingFields":{"type":"array","items":{"type":"string"},"description":"The fields logged by request logging"},"ipLogging":{"$ref":"#/components/schemas/IpLoggingType"},"requestBodyMaxLengthKb":{"type":"integer","description":"Request body maximum length for request logging","format":"int32"},"responseBodyMaxLengthKb":{"type":"integer","description":"Response body maximum length for request logging","format":"int32"},"disableLogging":{"type":"boolean","description":"Disable logging for request logging"},"id":{"type":"integer","description":"The unique identifier of the request logging. Only provide a value when updating.","format":"int64","nullable":true},"deployments":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyDeploymentSaveModel"},"description":"The list of deployments associated with the request logging"}},"additionalProperties":false},"IpLoggingType":{"enum":["ClientIP","ClientIPXForwardedForFirst","ClientIPXForwardedForAll","Disable"],"type":"string"}}}}
```

## The ApiPolicyTargetEndpointSaveModel object

```json
{"openapi":"3.0.1","info":{"title":"Frends API","version":"1.0"},"components":{"schemas":{"ApiPolicyTargetEndpointSaveModel":{"required":["path"],"type":"object","properties":{"requestLimit":{"type":"integer","description":"The maximum amount of requests. Not null value requires RequestLimitWindowInMinutes to be set.","format":"int32","nullable":true},"requestLimitWindowInMinutes":{"type":"integer","description":"The request limit window in minutes. Not null value requires RequestLimit to be set.","format":"int32","nullable":true},"path":{"type":"string","description":"The path of the target endpoint"},"method":{"$ref":"#/components/schemas/PolicyEndpointMethod"}},"additionalProperties":false},"PolicyEndpointMethod":{"enum":["All","Get","Post","Put","Head","Delete","Patch","Options","Connect","Trace"],"type":"string"}}}}
```

## The ApiPolicyTargetEndpointViewModel object

```json
{"openapi":"3.0.1","info":{"title":"Frends API","version":"1.0"},"components":{"schemas":{"ApiPolicyTargetEndpointViewModel":{"required":["path"],"type":"object","properties":{"requestLimit":{"type":"integer","description":"The maximum amount of requests. Not null value requires RequestLimitWindowInMinutes to be set.","format":"int32","nullable":true},"requestLimitWindowInMinutes":{"type":"integer","description":"The request limit window in minutes. Not null value requires RequestLimit to be set.","format":"int32","nullable":true},"path":{"type":"string","description":"The path of the target endpoint"},"method":{"$ref":"#/components/schemas/PolicyEndpointMethod"},"id":{"type":"integer","description":"The unique identifier of the target endpoint","format":"int64","readOnly":true}},"additionalProperties":false},"PolicyEndpointMethod":{"enum":["All","Get","Post","Put","Head","Delete","Patch","Options","Connect","Trace"],"type":"string"}}}}
```

## The ApiPolicyViewModel object

```json
{"openapi":"3.0.1","info":{"title":"Frends API","version":"1.0"},"components":{"schemas":{"ApiPolicyViewModel":{"required":["name"],"type":"object","properties":{"name":{"type":"string","description":"The name of the policy"},"description":{"type":"string","description":"The description of the policy","nullable":true},"tags":{"type":"array","items":{"type":"string"},"description":"The tags of the policy","nullable":true},"allowPublicAccess":{"type":"boolean","description":"Determines if public access is allowed"},"apiKeyName":{"type":"string","description":"The name of the API key"},"apiKeyLocation":{"$ref":"#/components/schemas/ParameterLocation"},"id":{"type":"integer","description":"The identifier of the policy","format":"int64","readOnly":true},"uniqueIdentifier":{"type":"string","description":"The globally unique identifier of the policy","format":"uuid","readOnly":true},"modifier":{"type":"string","description":"The modifier of the policy","readOnly":true},"modifiedUtc":{"type":"string","description":"The timestamp when the policy was last modified","format":"date-time","readOnly":true},"targetEndpoints":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyTargetEndpointViewModel"},"description":"The list of target endpoints associated with the policy","readOnly":true},"identities":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyIdentityViewModel"},"description":"The list of identities associated with the policy","readOnly":true},"apiKeyGroups":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyApiKeyGroupViewModel"},"description":"The list of API key groups associated with the policy","readOnly":true},"publicAccessDeployments":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyDeploymentViewModel"},"description":"The list of deployments connected with public access identity","readOnly":true},"requestLoggingOptions":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyRequestLoggingViewModel"},"description":"The list of request logging options associated with the api policy","readOnly":true}},"additionalProperties":false},"ParameterLocation":{"enum":["Query","Header","Path","Cookie"],"type":"string"},"ApiPolicyTargetEndpointViewModel":{"required":["path"],"type":"object","properties":{"requestLimit":{"type":"integer","description":"The maximum amount of requests. Not null value requires RequestLimitWindowInMinutes to be set.","format":"int32","nullable":true},"requestLimitWindowInMinutes":{"type":"integer","description":"The request limit window in minutes. Not null value requires RequestLimit to be set.","format":"int32","nullable":true},"path":{"type":"string","description":"The path of the target endpoint"},"method":{"$ref":"#/components/schemas/PolicyEndpointMethod"},"id":{"type":"integer","description":"The unique identifier of the target endpoint","format":"int64","readOnly":true}},"additionalProperties":false},"PolicyEndpointMethod":{"enum":["All","Get","Post","Put","Head","Delete","Patch","Options","Connect","Trace"],"type":"string"},"ApiPolicyIdentityViewModel":{"required":["issuers","name"],"type":"object","properties":{"requestLimit":{"type":"integer","description":"The maximum amount of requests. Not null value requires RequestLimitWindowInMinutes to be set.","format":"int32","nullable":true},"requestLimitWindowInMinutes":{"type":"integer","description":"The request limit window in minutes. Not null value requires RequestLimit to be set.","format":"int32","nullable":true},"isPrivateApplication":{"type":"boolean","description":"Determines if it is a private application"},"issuers":{"type":"array","items":{"type":"string"},"description":"The issuers of the identity"},"name":{"type":"string","description":"The name of the identity"},"throttlingByClaim":{"type":"string","description":"The throttling by claim for the identity","nullable":true},"priorityNumber":{"type":"integer","description":"In case of 2 or more matching identities, determines which identity to use. Lower number will be selected.","format":"int32"},"id":{"type":"integer","description":"The unique identifier of the identity","format":"int64","readOnly":true},"identityRules":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyIdentityRuleViewModel"}},"deployments":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyDeploymentViewModel"},"description":"The list of deployments associated with the identity"}},"additionalProperties":false},"ApiPolicyIdentityRuleViewModel":{"type":"object","properties":{"id":{"type":"integer","description":"The unique identifier of the identity rule","format":"int64","readOnly":true},"ruleType":{"$ref":"#/components/schemas/ApiAccessRuleType"},"claim":{"type":"string","description":"The claim associated with the identity rule","readOnly":true},"value":{"type":"string","description":"The value associated with the identity rule","readOnly":true},"matchType":{"$ref":"#/components/schemas/IdentityRuleMatchType"}},"additionalProperties":false},"ApiAccessRuleType":{"enum":["Allow","Deny"],"type":"string"},"IdentityRuleMatchType":{"enum":["Exact","Exists","Regex"],"type":"string"},"ApiPolicyDeploymentViewModel":{"required":["agentGroupName"],"type":"object","properties":{"agentGroupName":{"type":"string","description":"The Agent Group associated with the deployment"},"id":{"type":"integer","description":"The unique identifier of the deployment","format":"int64","readOnly":true},"deployerUserName":{"type":"string","description":"The username of the deployer"},"deployedUtc":{"type":"string","description":"The timestamp when the deployment occurred","format":"date-time"}},"additionalProperties":false},"ApiPolicyApiKeyGroupViewModel":{"required":["name"],"type":"object","properties":{"requestLimit":{"type":"integer","description":"The maximum amount of requests. Not null value requires RequestLimitWindowInMinutes to be set.","format":"int32","nullable":true},"requestLimitWindowInMinutes":{"type":"integer","description":"The request limit window in minutes. Not null value requires RequestLimit to be set.","format":"int32","nullable":true},"name":{"type":"string","description":"The name of the API key group"},"id":{"type":"integer","description":"The unique identifier of the API key group","format":"int64","readOnly":true},"apiPolicyApiKeyGroupAssignments":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyApiKeyGroupAssignmentViewModel"},"description":"The API group assignments","readOnly":true}},"additionalProperties":false},"ApiPolicyApiKeyGroupAssignmentViewModel":{"required":["apiKey"],"type":"object","properties":{"id":{"type":"integer","description":"The identifier of the assignment","format":"int64"},"apiKey":{"$ref":"#/components/schemas/ApiKeyViewModel"}},"additionalProperties":false},"ApiKeyViewModel":{"type":"object","properties":{"id":{"type":"integer","format":"int64"},"name":{"type":"string","nullable":true},"environment":{"type":"string","nullable":true},"value":{"type":"string","format":"uuid"}},"additionalProperties":false},"ApiPolicyRequestLoggingViewModel":{"required":["loggingFields","name"],"type":"object","properties":{"name":{"type":"string","description":"The name of the request logging"},"loggingFields":{"type":"array","items":{"type":"string"},"description":"The fields logged by request logging"},"ipLogging":{"$ref":"#/components/schemas/IpLoggingType"},"requestBodyMaxLengthKb":{"type":"integer","description":"Request body maximum length for request logging","format":"int32"},"responseBodyMaxLengthKb":{"type":"integer","description":"Response body maximum length for request logging","format":"int32"},"disableLogging":{"type":"boolean","description":"Disable logging for request logging"},"id":{"type":"integer","description":"The unique identifier of the request logging","format":"int64","readOnly":true},"deployments":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyDeploymentViewModel"},"description":"The list of deployments associated with the request logging"}},"additionalProperties":false},"IpLoggingType":{"enum":["ClientIP","ClientIPXForwardedForFirst","ClientIPXForwardedForAll","Disable"],"type":"string"}}}}
```

## The ApiPolicyViewModelResponse object

```json
{"openapi":"3.0.1","info":{"title":"Frends API","version":"1.0"},"components":{"schemas":{"ApiPolicyViewModelResponse":{"required":["Data"],"type":"object","properties":{"data":{"$ref":"#/components/schemas/ApiPolicyViewModel"}},"additionalProperties":false},"ApiPolicyViewModel":{"required":["name"],"type":"object","properties":{"name":{"type":"string","description":"The name of the policy"},"description":{"type":"string","description":"The description of the policy","nullable":true},"tags":{"type":"array","items":{"type":"string"},"description":"The tags of the policy","nullable":true},"allowPublicAccess":{"type":"boolean","description":"Determines if public access is allowed"},"apiKeyName":{"type":"string","description":"The name of the API key"},"apiKeyLocation":{"$ref":"#/components/schemas/ParameterLocation"},"id":{"type":"integer","description":"The identifier of the policy","format":"int64","readOnly":true},"uniqueIdentifier":{"type":"string","description":"The globally unique identifier of the policy","format":"uuid","readOnly":true},"modifier":{"type":"string","description":"The modifier of the policy","readOnly":true},"modifiedUtc":{"type":"string","description":"The timestamp when the policy was last modified","format":"date-time","readOnly":true},"targetEndpoints":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyTargetEndpointViewModel"},"description":"The list of target endpoints associated with the policy","readOnly":true},"identities":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyIdentityViewModel"},"description":"The list of identities associated with the policy","readOnly":true},"apiKeyGroups":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyApiKeyGroupViewModel"},"description":"The list of API key groups associated with the policy","readOnly":true},"publicAccessDeployments":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyDeploymentViewModel"},"description":"The list of deployments connected with public access identity","readOnly":true},"requestLoggingOptions":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyRequestLoggingViewModel"},"description":"The list of request logging options associated with the api policy","readOnly":true}},"additionalProperties":false},"ParameterLocation":{"enum":["Query","Header","Path","Cookie"],"type":"string"},"ApiPolicyTargetEndpointViewModel":{"required":["path"],"type":"object","properties":{"requestLimit":{"type":"integer","description":"The maximum amount of requests. Not null value requires RequestLimitWindowInMinutes to be set.","format":"int32","nullable":true},"requestLimitWindowInMinutes":{"type":"integer","description":"The request limit window in minutes. Not null value requires RequestLimit to be set.","format":"int32","nullable":true},"path":{"type":"string","description":"The path of the target endpoint"},"method":{"$ref":"#/components/schemas/PolicyEndpointMethod"},"id":{"type":"integer","description":"The unique identifier of the target endpoint","format":"int64","readOnly":true}},"additionalProperties":false},"PolicyEndpointMethod":{"enum":["All","Get","Post","Put","Head","Delete","Patch","Options","Connect","Trace"],"type":"string"},"ApiPolicyIdentityViewModel":{"required":["issuers","name"],"type":"object","properties":{"requestLimit":{"type":"integer","description":"The maximum amount of requests. Not null value requires RequestLimitWindowInMinutes to be set.","format":"int32","nullable":true},"requestLimitWindowInMinutes":{"type":"integer","description":"The request limit window in minutes. Not null value requires RequestLimit to be set.","format":"int32","nullable":true},"isPrivateApplication":{"type":"boolean","description":"Determines if it is a private application"},"issuers":{"type":"array","items":{"type":"string"},"description":"The issuers of the identity"},"name":{"type":"string","description":"The name of the identity"},"throttlingByClaim":{"type":"string","description":"The throttling by claim for the identity","nullable":true},"priorityNumber":{"type":"integer","description":"In case of 2 or more matching identities, determines which identity to use. Lower number will be selected.","format":"int32"},"id":{"type":"integer","description":"The unique identifier of the identity","format":"int64","readOnly":true},"identityRules":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyIdentityRuleViewModel"}},"deployments":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyDeploymentViewModel"},"description":"The list of deployments associated with the identity"}},"additionalProperties":false},"ApiPolicyIdentityRuleViewModel":{"type":"object","properties":{"id":{"type":"integer","description":"The unique identifier of the identity rule","format":"int64","readOnly":true},"ruleType":{"$ref":"#/components/schemas/ApiAccessRuleType"},"claim":{"type":"string","description":"The claim associated with the identity rule","readOnly":true},"value":{"type":"string","description":"The value associated with the identity rule","readOnly":true},"matchType":{"$ref":"#/components/schemas/IdentityRuleMatchType"}},"additionalProperties":false},"ApiAccessRuleType":{"enum":["Allow","Deny"],"type":"string"},"IdentityRuleMatchType":{"enum":["Exact","Exists","Regex"],"type":"string"},"ApiPolicyDeploymentViewModel":{"required":["agentGroupName"],"type":"object","properties":{"agentGroupName":{"type":"string","description":"The Agent Group associated with the deployment"},"id":{"type":"integer","description":"The unique identifier of the deployment","format":"int64","readOnly":true},"deployerUserName":{"type":"string","description":"The username of the deployer"},"deployedUtc":{"type":"string","description":"The timestamp when the deployment occurred","format":"date-time"}},"additionalProperties":false},"ApiPolicyApiKeyGroupViewModel":{"required":["name"],"type":"object","properties":{"requestLimit":{"type":"integer","description":"The maximum amount of requests. Not null value requires RequestLimitWindowInMinutes to be set.","format":"int32","nullable":true},"requestLimitWindowInMinutes":{"type":"integer","description":"The request limit window in minutes. Not null value requires RequestLimit to be set.","format":"int32","nullable":true},"name":{"type":"string","description":"The name of the API key group"},"id":{"type":"integer","description":"The unique identifier of the API key group","format":"int64","readOnly":true},"apiPolicyApiKeyGroupAssignments":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyApiKeyGroupAssignmentViewModel"},"description":"The API group assignments","readOnly":true}},"additionalProperties":false},"ApiPolicyApiKeyGroupAssignmentViewModel":{"required":["apiKey"],"type":"object","properties":{"id":{"type":"integer","description":"The identifier of the assignment","format":"int64"},"apiKey":{"$ref":"#/components/schemas/ApiKeyViewModel"}},"additionalProperties":false},"ApiKeyViewModel":{"type":"object","properties":{"id":{"type":"integer","format":"int64"},"name":{"type":"string","nullable":true},"environment":{"type":"string","nullable":true},"value":{"type":"string","format":"uuid"}},"additionalProperties":false},"ApiPolicyRequestLoggingViewModel":{"required":["loggingFields","name"],"type":"object","properties":{"name":{"type":"string","description":"The name of the request logging"},"loggingFields":{"type":"array","items":{"type":"string"},"description":"The fields logged by request logging"},"ipLogging":{"$ref":"#/components/schemas/IpLoggingType"},"requestBodyMaxLengthKb":{"type":"integer","description":"Request body maximum length for request logging","format":"int32"},"responseBodyMaxLengthKb":{"type":"integer","description":"Response body maximum length for request logging","format":"int32"},"disableLogging":{"type":"boolean","description":"Disable logging for request logging"},"id":{"type":"integer","description":"The unique identifier of the request logging","format":"int64","readOnly":true},"deployments":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyDeploymentViewModel"},"description":"The list of deployments associated with the request logging"}},"additionalProperties":false},"IpLoggingType":{"enum":["ClientIP","ClientIPXForwardedForFirst","ClientIPXForwardedForAll","Disable"],"type":"string"}}}}
```

## The ApiProcessTemplateRequest object

```json
{"openapi":"3.0.1","info":{"title":"Frends API","version":"1.0"},"components":{"schemas":{"ApiProcessTemplateRequest":{"required":["Operation","Path"],"type":"object","properties":{"path":{"type":"string","description":"The path of the HTTP endpoint, as specified in the API specification"},"operation":{"type":"string","description":"The operation of the endpoint (e.g. GET)"}},"additionalProperties":false}}}}
```

## The CommentInstancesQueryModel object

```json
{"openapi":"3.0.1","info":{"title":"Frends API","version":"1.0"},"components":{"schemas":{"CommentInstancesQueryModel":{"required":["comment","instanceIds"],"type":"object","properties":{"comment":{"type":"string"},"processGuids":{"type":"array","items":{"type":"string","format":"uuid"},"nullable":true},"instanceIds":{"type":"array","items":{"type":"integer","format":"int64"}}},"additionalProperties":false}}}}
```

## The CreateProcessFromTemplateRequestBody object

```json
{"openapi":"3.0.1","info":{"title":"Frends API","version":"1.0"},"components":{"schemas":{"CreateProcessFromTemplateRequestBody":{"required":["IgnoreProcessTags"],"type":"object","properties":{"name":{"minLength":1,"type":"string","description":"Element name"},"description":{"type":"string","description":"Element description","nullable":true},"processVariables":{"type":"array","items":{"$ref":"#/components/schemas/ProcessVariable"},"nullable":true},"ignoreProcessTags":{"type":"boolean","description":"If true the Process will not be created with the predefined tags"}},"additionalProperties":false},"ProcessVariable":{"type":"object","properties":{"name":{"type":"string","nullable":true},"value":{"type":"string","nullable":true},"isSecret":{"type":"boolean"},"mode":{"type":"string","nullable":true},"description":{"type":"string","nullable":true}},"additionalProperties":false}}}}
```

## The CreateTemplateFromProcessRequestBody object

```json
{"openapi":"3.0.1","info":{"title":"Frends API","version":"1.0"},"components":{"schemas":{"CreateTemplateFromProcessRequestBody":{"required":["ProcessId"],"type":"object","properties":{"name":{"minLength":1,"type":"string","description":"Element name"},"description":{"type":"string","description":"Element description","nullable":true},"processVariables":{"type":"array","items":{"$ref":"#/components/schemas/ProcessVariable"},"nullable":true},"processId":{"type":"integer","description":"Process id","format":"int64"},"guid":{"type":"string","format":"uuid"},"templateMajorVersion":{"type":"integer","description":"Templates major version","format":"int32","nullable":true},"templateMinorVersion":{"type":"integer","description":"Templates minor version","format":"int32","nullable":true},"templateTags":{"type":"array","items":{"type":"string"},"description":"Tags for the Process template","nullable":true},"processTags":{"type":"array","items":{"type":"string"},"description":"Predefined tags for Processes created from the template","nullable":true},"linkProcessToCreatedTemplate":{"type":"boolean","description":"Link the Process to the created Template","nullable":true}},"additionalProperties":false},"ProcessVariable":{"type":"object","properties":{"name":{"type":"string","nullable":true},"value":{"type":"string","nullable":true},"isSecret":{"type":"boolean"},"mode":{"type":"string","nullable":true},"description":{"type":"string","nullable":true}},"additionalProperties":false}}}}
```

## The DtoAgentGet object

```json
{"openapi":"3.0.1","info":{"title":"Frends API","version":"1.0"},"components":{"schemas":{"DtoAgentGet":{"required":["IsCloudAgent","IsGateway","Name"],"type":"object","properties":{"url":{"type":"string","description":"The hostname or address for the agent. Can either be full URL https://example.org:1234 or hostname subdomain.example.org","readOnly":true},"httpPorts":{"type":"array","items":{"type":"string"},"description":"List of http ports the Agent listens to. If the Url is a full address (schema://hostname:port?) this can be ignored.","readOnly":true},"httpsPorts":{"type":"array","items":{"type":"string"},"description":"List of https ports the Agent listens to. If the Url is a full address (schema://hostname:port?) this can be ignored.","readOnly":true},"id":{"type":"integer","description":"Agent Identifier","format":"int64"},"name":{"type":"string","description":"Agent name","readOnly":true},"isGateway":{"type":"boolean","description":"If the agent is a Gateway Agent. If true, these Agents are the ones that should primarily be accessible from the internet.","readOnly":true},"isCloudAgent":{"type":"boolean","description":"If the agent is a Cloud Agent. If true, these Agents are managed by Frends.","readOnly":true}},"additionalProperties":false}}}}
```

## The DtoAgentGroupBase object

```json
{"openapi":"3.0.1","info":{"title":"Frends API","version":"1.0"},"components":{"schemas":{"DtoAgentGroupBase":{"required":["DisplayName","Id"],"type":"object","properties":{"id":{"type":"integer","description":"Unique identifier for the Agent Group","format":"int64","readOnly":true},"displayName":{"type":"string","description":"Display name for the Agent Group","readOnly":true}},"additionalProperties":false}}}}
```

## The DtoAgentGroupGet object

```json
{"openapi":"3.0.1","info":{"title":"Frends API","version":"1.0"},"components":{"schemas":{"DtoAgentGroupGet":{"required":["Agents","Environment","InternalName","IsCrossPlatform"],"type":"object","properties":{"id":{"type":"integer","description":"Unique identifier for the Agent Group","format":"int64","readOnly":true},"displayName":{"type":"string","description":"Display name for the Agent Group","readOnly":true},"internalName":{"type":"string","description":"Internal name used by Frends for the Agent Group","readOnly":true},"isCrossPlatform":{"type":"boolean","description":"Indicates whether the Agents in the group can be installed on Windows and Linux machines","readOnly":true},"agents":{"type":"array","items":{"type":"string"},"description":"The Agents that belong to the Agent Group","readOnly":true},"environment":{"$ref":"#/components/schemas/DtoEnvironmentBase"},"agentDetails":{"type":"array","items":{"$ref":"#/components/schemas/DtoAgentGet"},"description":"Details about the Agents that belong to the Agent Group","readOnly":true}},"additionalProperties":false},"DtoEnvironmentBase":{"required":["DisplayName","Id"],"type":"object","properties":{"id":{"type":"integer","description":"Unique identifier for the Environment","format":"int64","readOnly":true},"displayName":{"type":"string","description":"Display name for the Environment","readOnly":true}},"additionalProperties":false},"DtoAgentGet":{"required":["IsCloudAgent","IsGateway","Name"],"type":"object","properties":{"url":{"type":"string","description":"The hostname or address for the agent. Can either be full URL https://example.org:1234 or hostname subdomain.example.org","readOnly":true},"httpPorts":{"type":"array","items":{"type":"string"},"description":"List of http ports the Agent listens to. If the Url is a full address (schema://hostname:port?) this can be ignored.","readOnly":true},"httpsPorts":{"type":"array","items":{"type":"string"},"description":"List of https ports the Agent listens to. If the Url is a full address (schema://hostname:port?) this can be ignored.","readOnly":true},"id":{"type":"integer","description":"Agent Identifier","format":"int64"},"name":{"type":"string","description":"Agent name","readOnly":true},"isGateway":{"type":"boolean","description":"If the agent is a Gateway Agent. If true, these Agents are the ones that should primarily be accessible from the internet.","readOnly":true},"isCloudAgent":{"type":"boolean","description":"If the agent is a Cloud Agent. If true, these Agents are managed by Frends.","readOnly":true}},"additionalProperties":false}}}}
```

## The DtoAgentGroupGetIListResponse object

```json
{"openapi":"3.0.1","info":{"title":"Frends API","version":"1.0"},"components":{"schemas":{"DtoAgentGroupGetIListResponse":{"required":["Data"],"type":"object","properties":{"data":{"type":"array","items":{"$ref":"#/components/schemas/DtoAgentGroupGet"},"description":"Response data","nullable":true}},"additionalProperties":false},"DtoAgentGroupGet":{"required":["Agents","Environment","InternalName","IsCrossPlatform"],"type":"object","properties":{"id":{"type":"integer","description":"Unique identifier for the Agent Group","format":"int64","readOnly":true},"displayName":{"type":"string","description":"Display name for the Agent Group","readOnly":true},"internalName":{"type":"string","description":"Internal name used by Frends for the Agent Group","readOnly":true},"isCrossPlatform":{"type":"boolean","description":"Indicates whether the Agents in the group can be installed on Windows and Linux machines","readOnly":true},"agents":{"type":"array","items":{"type":"string"},"description":"The Agents that belong to the Agent Group","readOnly":true},"environment":{"$ref":"#/components/schemas/DtoEnvironmentBase"},"agentDetails":{"type":"array","items":{"$ref":"#/components/schemas/DtoAgentGet"},"description":"Details about the Agents that belong to the Agent Group","readOnly":true}},"additionalProperties":false},"DtoEnvironmentBase":{"required":["DisplayName","Id"],"type":"object","properties":{"id":{"type":"integer","description":"Unique identifier for the Environment","format":"int64","readOnly":true},"displayName":{"type":"string","description":"Display name for the Environment","readOnly":true}},"additionalProperties":false},"DtoAgentGet":{"required":["IsCloudAgent","IsGateway","Name"],"type":"object","properties":{"url":{"type":"string","description":"The hostname or address for the agent. Can either be full URL https://example.org:1234 or hostname subdomain.example.org","readOnly":true},"httpPorts":{"type":"array","items":{"type":"string"},"description":"List of http ports the Agent listens to. If the Url is a full address (schema://hostname:port?) this can be ignored.","readOnly":true},"httpsPorts":{"type":"array","items":{"type":"string"},"description":"List of https ports the Agent listens to. If the Url is a full address (schema://hostname:port?) this can be ignored.","readOnly":true},"id":{"type":"integer","description":"Agent Identifier","format":"int64"},"name":{"type":"string","description":"Agent name","readOnly":true},"isGateway":{"type":"boolean","description":"If the agent is a Gateway Agent. If true, these Agents are the ones that should primarily be accessible from the internet.","readOnly":true},"isCloudAgent":{"type":"boolean","description":"If the agent is a Cloud Agent. If true, these Agents are managed by Frends.","readOnly":true}},"additionalProperties":false}}}}
```

## The DtoAgentGroupGetResponse object

```json
{"openapi":"3.0.1","info":{"title":"Frends API","version":"1.0"},"components":{"schemas":{"DtoAgentGroupGetResponse":{"required":["Data"],"type":"object","properties":{"data":{"$ref":"#/components/schemas/DtoAgentGroupGet"}},"additionalProperties":false},"DtoAgentGroupGet":{"required":["Agents","Environment","InternalName","IsCrossPlatform"],"type":"object","properties":{"id":{"type":"integer","description":"Unique identifier for the Agent Group","format":"int64","readOnly":true},"displayName":{"type":"string","description":"Display name for the Agent Group","readOnly":true},"internalName":{"type":"string","description":"Internal name used by Frends for the Agent Group","readOnly":true},"isCrossPlatform":{"type":"boolean","description":"Indicates whether the Agents in the group can be installed on Windows and Linux machines","readOnly":true},"agents":{"type":"array","items":{"type":"string"},"description":"The Agents that belong to the Agent Group","readOnly":true},"environment":{"$ref":"#/components/schemas/DtoEnvironmentBase"},"agentDetails":{"type":"array","items":{"$ref":"#/components/schemas/DtoAgentGet"},"description":"Details about the Agents that belong to the Agent Group","readOnly":true}},"additionalProperties":false},"DtoEnvironmentBase":{"required":["DisplayName","Id"],"type":"object","properties":{"id":{"type":"integer","description":"Unique identifier for the Environment","format":"int64","readOnly":true},"displayName":{"type":"string","description":"Display name for the Environment","readOnly":true}},"additionalProperties":false},"DtoAgentGet":{"required":["IsCloudAgent","IsGateway","Name"],"type":"object","properties":{"url":{"type":"string","description":"The hostname or address for the agent. Can either be full URL https://example.org:1234 or hostname subdomain.example.org","readOnly":true},"httpPorts":{"type":"array","items":{"type":"string"},"description":"List of http ports the Agent listens to. If the Url is a full address (schema://hostname:port?) this can be ignored.","readOnly":true},"httpsPorts":{"type":"array","items":{"type":"string"},"description":"List of https ports the Agent listens to. If the Url is a full address (schema://hostname:port?) this can be ignored.","readOnly":true},"id":{"type":"integer","description":"Agent Identifier","format":"int64"},"name":{"type":"string","description":"Agent name","readOnly":true},"isGateway":{"type":"boolean","description":"If the agent is a Gateway Agent. If true, these Agents are the ones that should primarily be accessible from the internet.","readOnly":true},"isCloudAgent":{"type":"boolean","description":"If the agent is a Cloud Agent. If true, these Agents are managed by Frends.","readOnly":true}},"additionalProperties":false}}}}
```

## The DtoAgentStatusGet object

```json
{"openapi":"3.0.1","info":{"title":"Frends API","version":"1.0"},"components":{"schemas":{"DtoAgentStatusGet":{"required":["IsCloudAgent","IsGateway","Name"],"type":"object","properties":{"url":{"type":"string","description":"The hostname or address for the agent. Can either be full URL https://example.org:1234 or hostname subdomain.example.org","readOnly":true},"httpPorts":{"type":"array","items":{"type":"string"},"description":"List of http ports the Agent listens to. If the Url is a full address (schema://hostname:port?) this can be ignored.","readOnly":true},"httpsPorts":{"type":"array","items":{"type":"string"},"description":"List of https ports the Agent listens to. If the Url is a full address (schema://hostname:port?) this can be ignored.","readOnly":true},"id":{"type":"integer","description":"Agent Identifier","format":"int64"},"name":{"type":"string","description":"Agent name","readOnly":true},"isGateway":{"type":"boolean","description":"If the agent is a Gateway Agent. If true, these Agents are the ones that should primarily be accessible from the internet.","readOnly":true},"isCloudAgent":{"type":"boolean","description":"If the agent is a Cloud Agent. If true, these Agents are managed by Frends.","readOnly":true},"lastError":{"type":"string","description":"Date&Time of the last error occurred.","format":"date-time","nullable":true,"readOnly":true},"lastUpdate":{"type":"string","description":"Date&Time of the last agent update occurred.","format":"date-time","nullable":true,"readOnly":true},"lastStatus":{"type":"string","description":"Last known Agent status.","nullable":true,"readOnly":true}},"additionalProperties":false}}}}
```

## The DtoAgentStatusGetResponse object

```json
{"openapi":"3.0.1","info":{"title":"Frends API","version":"1.0"},"components":{"schemas":{"DtoAgentStatusGetResponse":{"required":["Data"],"type":"object","properties":{"data":{"$ref":"#/components/schemas/DtoAgentStatusGet"}},"additionalProperties":false},"DtoAgentStatusGet":{"required":["IsCloudAgent","IsGateway","Name"],"type":"object","properties":{"url":{"type":"string","description":"The hostname or address for the agent. Can either be full URL https://example.org:1234 or hostname subdomain.example.org","readOnly":true},"httpPorts":{"type":"array","items":{"type":"string"},"description":"List of http ports the Agent listens to. If the Url is a full address (schema://hostname:port?) this can be ignored.","readOnly":true},"httpsPorts":{"type":"array","items":{"type":"string"},"description":"List of https ports the Agent listens to. If the Url is a full address (schema://hostname:port?) this can be ignored.","readOnly":true},"id":{"type":"integer","description":"Agent Identifier","format":"int64"},"name":{"type":"string","description":"Agent name","readOnly":true},"isGateway":{"type":"boolean","description":"If the agent is a Gateway Agent. If true, these Agents are the ones that should primarily be accessible from the internet.","readOnly":true},"isCloudAgent":{"type":"boolean","description":"If the agent is a Cloud Agent. If true, these Agents are managed by Frends.","readOnly":true},"lastError":{"type":"string","description":"Date&Time of the last error occurred.","format":"date-time","nullable":true,"readOnly":true},"lastUpdate":{"type":"string","description":"Date&Time of the last agent update occurred.","format":"date-time","nullable":true,"readOnly":true},"lastStatus":{"type":"string","description":"Last known Agent status.","nullable":true,"readOnly":true}},"additionalProperties":false}}}}
```

## The DtoApiKeyCreate object

```json
{"openapi":"3.0.1","info":{"title":"Frends API","version":"1.0"},"components":{"schemas":{"DtoApiKeyCreate":{"required":["EnvironmentId"],"type":"object","properties":{"name":{"type":"string","description":"Name of the API key","nullable":true},"environmentId":{"type":"integer","description":"Identifier of the Environment of the API key","format":"int64"}},"additionalProperties":false}}}}
```

## The DtoApiKeyGet object

```json
{"openapi":"3.0.1","info":{"title":"Frends API","version":"1.0"},"components":{"schemas":{"DtoApiKeyGet":{"required":["Environment","Id","Modified","Modifier","Value"],"type":"object","properties":{"name":{"type":"string","description":"Name of the API key","nullable":true},"id":{"type":"integer","description":"Unique identifier for the API key","format":"int64"},"value":{"type":"string","description":"Value of the API key","format":"uuid"},"modified":{"type":"string","description":"The date and time when the API key was last modified","format":"date-time"},"modifier":{"type":"string","description":"The user who last modified the API key","nullable":true},"environment":{"$ref":"#/components/schemas/DtoEnvironmentBase"}},"additionalProperties":false},"DtoEnvironmentBase":{"required":["DisplayName","Id"],"type":"object","properties":{"id":{"type":"integer","description":"Unique identifier for the Environment","format":"int64","readOnly":true},"displayName":{"type":"string","description":"Display name for the Environment","readOnly":true}},"additionalProperties":false}}}}
```

## The DtoApiKeyGetResponse object

```json
{"openapi":"3.0.1","info":{"title":"Frends API","version":"1.0"},"components":{"schemas":{"DtoApiKeyGetResponse":{"required":["Data"],"type":"object","properties":{"data":{"$ref":"#/components/schemas/DtoApiKeyGet"}},"additionalProperties":false},"DtoApiKeyGet":{"required":["Environment","Id","Modified","Modifier","Value"],"type":"object","properties":{"name":{"type":"string","description":"Name of the API key","nullable":true},"id":{"type":"integer","description":"Unique identifier for the API key","format":"int64"},"value":{"type":"string","description":"Value of the API key","format":"uuid"},"modified":{"type":"string","description":"The date and time when the API key was last modified","format":"date-time"},"modifier":{"type":"string","description":"The user who last modified the API key","nullable":true},"environment":{"$ref":"#/components/schemas/DtoEnvironmentBase"}},"additionalProperties":false},"DtoEnvironmentBase":{"required":["DisplayName","Id"],"type":"object","properties":{"id":{"type":"integer","description":"Unique identifier for the Environment","format":"int64","readOnly":true},"displayName":{"type":"string","description":"Display name for the Environment","readOnly":true}},"additionalProperties":false}}}}
```

## The DtoApiKeyUpdate object

```json
{"openapi":"3.0.1","info":{"title":"Frends API","version":"1.0"},"components":{"schemas":{"DtoApiKeyUpdate":{"required":["Name"],"type":"object","properties":{"name":{"type":"string","description":"Name of the API key","nullable":true}},"additionalProperties":false}}}}
```

## The DtoApiSpecification object

```json
{"openapi":"3.0.1","info":{"title":"Frends API","version":"1.0"},"components":{"schemas":{"DtoApiSpecification":{"required":["ActiveVersion","Id","Name"],"type":"object","properties":{"id":{"type":"integer","description":"Unique identifier for the API specification","format":"int64"},"name":{"type":"string","description":"Name of the API specification"},"activeVersion":{"type":"integer","description":"Currently active version of the API specification","format":"int32"},"description":{"type":"string","description":"Description for the API specification","nullable":true}},"additionalProperties":false}}}}
```

## The DtoApiSpecificationPagedResponse object

```json
{"openapi":"3.0.1","info":{"title":"Frends API","version":"1.0"},"components":{"schemas":{"DtoApiSpecificationPagedResponse":{"required":["Data","Paging"],"type":"object","properties":{"data":{"type":"array","items":{"$ref":"#/components/schemas/DtoApiSpecification"},"description":"Response data"},"paging":{"$ref":"#/components/schemas/PagingModel"}},"additionalProperties":false},"DtoApiSpecification":{"required":["ActiveVersion","Id","Name"],"type":"object","properties":{"id":{"type":"integer","description":"Unique identifier for the API specification","format":"int64"},"name":{"type":"string","description":"Name of the API specification"},"activeVersion":{"type":"integer","description":"Currently active version of the API specification","format":"int32"},"description":{"type":"string","description":"Description for the API specification","nullable":true}},"additionalProperties":false},"PagingModel":{"required":["CurrentPage","FirstPage","LastPage","PageSize","TotalCount"],"type":"object","properties":{"currentPage":{"type":"integer","description":"Current page","format":"int32"},"pageSize":{"type":"integer","description":"Number of entries per page","format":"int32"},"totalCount":{"type":"integer","description":"Total number of entries","format":"int32"},"firstPage":{"type":"string","description":"Url of the first page","format":"uri","nullable":true},"lastPage":{"type":"string","description":"Url of the last page","format":"uri","nullable":true},"nextPage":{"type":"string","description":"Url of the next page","format":"uri","nullable":true},"previousPage":{"type":"string","description":"Url of the previous page","format":"uri","nullable":true}},"additionalProperties":false}}}}
```

## The DtoApiSpecificationResponse object

```json
{"openapi":"3.0.1","info":{"title":"Frends API","version":"1.0"},"components":{"schemas":{"DtoApiSpecificationResponse":{"required":["Data"],"type":"object","properties":{"data":{"$ref":"#/components/schemas/DtoApiSpecification"}},"additionalProperties":false},"DtoApiSpecification":{"required":["ActiveVersion","Id","Name"],"type":"object","properties":{"id":{"type":"integer","description":"Unique identifier for the API specification","format":"int64"},"name":{"type":"string","description":"Name of the API specification"},"activeVersion":{"type":"integer","description":"Currently active version of the API specification","format":"int32"},"description":{"type":"string","description":"Description for the API specification","nullable":true}},"additionalProperties":false}}}}
```

## The DtoChildSchemaCreate object

```json
{"openapi":"3.0.1","info":{"title":"Frends API","version":"1.0"},"components":{"schemas":{"DtoChildSchemaCreate":{"required":["Type"],"type":"object","properties":{"name":{"type":"string"},"type":{"$ref":"#/components/schemas/EnvironmentVariableChildType"}},"additionalProperties":false},"EnvironmentVariableChildType":{"enum":["String","Array","Secret","Number","Boolean"],"type":"string"}}}}
```

## The DtoEnvironmentBase object

```json
{"openapi":"3.0.1","info":{"title":"Frends API","version":"1.0"},"components":{"schemas":{"DtoEnvironmentBase":{"required":["DisplayName","Id"],"type":"object","properties":{"id":{"type":"integer","description":"Unique identifier for the Environment","format":"int64","readOnly":true},"displayName":{"type":"string","description":"Display name for the Environment","readOnly":true}},"additionalProperties":false}}}}
```

## The DtoEnvironmentGet object

```json
{"openapi":"3.0.1","info":{"title":"Frends API","version":"1.0"},"components":{"schemas":{"DtoEnvironmentGet":{"required":["AgentGroups","InternalName"],"type":"object","properties":{"id":{"type":"integer","description":"Unique identifier for the Environment","format":"int64","readOnly":true},"displayName":{"type":"string","description":"Display name for the Environment","readOnly":true},"agentGroups":{"type":"array","items":{"$ref":"#/components/schemas/DtoAgentGroupGet"},"description":"The Agent Groups that belong to the Environment","readOnly":true},"internalName":{"type":"string","description":"Internal name used by Frends for the Environment","readOnly":true}},"additionalProperties":false},"DtoAgentGroupGet":{"required":["Agents","Environment","InternalName","IsCrossPlatform"],"type":"object","properties":{"id":{"type":"integer","description":"Unique identifier for the Agent Group","format":"int64","readOnly":true},"displayName":{"type":"string","description":"Display name for the Agent Group","readOnly":true},"internalName":{"type":"string","description":"Internal name used by Frends for the Agent Group","readOnly":true},"isCrossPlatform":{"type":"boolean","description":"Indicates whether the Agents in the group can be installed on Windows and Linux machines","readOnly":true},"agents":{"type":"array","items":{"type":"string"},"description":"The Agents that belong to the Agent Group","readOnly":true},"environment":{"$ref":"#/components/schemas/DtoEnvironmentBase"},"agentDetails":{"type":"array","items":{"$ref":"#/components/schemas/DtoAgentGet"},"description":"Details about the Agents that belong to the Agent Group","readOnly":true}},"additionalProperties":false},"DtoEnvironmentBase":{"required":["DisplayName","Id"],"type":"object","properties":{"id":{"type":"integer","description":"Unique identifier for the Environment","format":"int64","readOnly":true},"displayName":{"type":"string","description":"Display name for the Environment","readOnly":true}},"additionalProperties":false},"DtoAgentGet":{"required":["IsCloudAgent","IsGateway","Name"],"type":"object","properties":{"url":{"type":"string","description":"The hostname or address for the agent. Can either be full URL https://example.org:1234 or hostname subdomain.example.org","readOnly":true},"httpPorts":{"type":"array","items":{"type":"string"},"description":"List of http ports the Agent listens to. If the Url is a full address (schema://hostname:port?) this can be ignored.","readOnly":true},"httpsPorts":{"type":"array","items":{"type":"string"},"description":"List of https ports the Agent listens to. If the Url is a full address (schema://hostname:port?) this can be ignored.","readOnly":true},"id":{"type":"integer","description":"Agent Identifier","format":"int64"},"name":{"type":"string","description":"Agent name","readOnly":true},"isGateway":{"type":"boolean","description":"If the agent is a Gateway Agent. If true, these Agents are the ones that should primarily be accessible from the internet.","readOnly":true},"isCloudAgent":{"type":"boolean","description":"If the agent is a Cloud Agent. If true, these Agents are managed by Frends.","readOnly":true}},"additionalProperties":false}}}}
```

## The DtoEnvironmentGetIListResponse object

```json
{"openapi":"3.0.1","info":{"title":"Frends API","version":"1.0"},"components":{"schemas":{"DtoEnvironmentGetIListResponse":{"required":["Data"],"type":"object","properties":{"data":{"type":"array","items":{"$ref":"#/components/schemas/DtoEnvironmentGet"},"description":"Response data","nullable":true}},"additionalProperties":false},"DtoEnvironmentGet":{"required":["AgentGroups","InternalName"],"type":"object","properties":{"id":{"type":"integer","description":"Unique identifier for the Environment","format":"int64","readOnly":true},"displayName":{"type":"string","description":"Display name for the Environment","readOnly":true},"agentGroups":{"type":"array","items":{"$ref":"#/components/schemas/DtoAgentGroupGet"},"description":"The Agent Groups that belong to the Environment","readOnly":true},"internalName":{"type":"string","description":"Internal name used by Frends for the Environment","readOnly":true}},"additionalProperties":false},"DtoAgentGroupGet":{"required":["Agents","Environment","InternalName","IsCrossPlatform"],"type":"object","properties":{"id":{"type":"integer","description":"Unique identifier for the Agent Group","format":"int64","readOnly":true},"displayName":{"type":"string","description":"Display name for the Agent Group","readOnly":true},"internalName":{"type":"string","description":"Internal name used by Frends for the Agent Group","readOnly":true},"isCrossPlatform":{"type":"boolean","description":"Indicates whether the Agents in the group can be installed on Windows and Linux machines","readOnly":true},"agents":{"type":"array","items":{"type":"string"},"description":"The Agents that belong to the Agent Group","readOnly":true},"environment":{"$ref":"#/components/schemas/DtoEnvironmentBase"},"agentDetails":{"type":"array","items":{"$ref":"#/components/schemas/DtoAgentGet"},"description":"Details about the Agents that belong to the Agent Group","readOnly":true}},"additionalProperties":false},"DtoEnvironmentBase":{"required":["DisplayName","Id"],"type":"object","properties":{"id":{"type":"integer","description":"Unique identifier for the Environment","format":"int64","readOnly":true},"displayName":{"type":"string","description":"Display name for the Environment","readOnly":true}},"additionalProperties":false},"DtoAgentGet":{"required":["IsCloudAgent","IsGateway","Name"],"type":"object","properties":{"url":{"type":"string","description":"The hostname or address for the agent. Can either be full URL https://example.org:1234 or hostname subdomain.example.org","readOnly":true},"httpPorts":{"type":"array","items":{"type":"string"},"description":"List of http ports the Agent listens to. If the Url is a full address (schema://hostname:port?) this can be ignored.","readOnly":true},"httpsPorts":{"type":"array","items":{"type":"string"},"description":"List of https ports the Agent listens to. If the Url is a full address (schema://hostname:port?) this can be ignored.","readOnly":true},"id":{"type":"integer","description":"Agent Identifier","format":"int64"},"name":{"type":"string","description":"Agent name","readOnly":true},"isGateway":{"type":"boolean","description":"If the agent is a Gateway Agent. If true, these Agents are the ones that should primarily be accessible from the internet.","readOnly":true},"isCloudAgent":{"type":"boolean","description":"If the agent is a Cloud Agent. If true, these Agents are managed by Frends.","readOnly":true}},"additionalProperties":false}}}}
```

## The DtoEnvironmentGetResponse object

```json
{"openapi":"3.0.1","info":{"title":"Frends API","version":"1.0"},"components":{"schemas":{"DtoEnvironmentGetResponse":{"required":["Data"],"type":"object","properties":{"data":{"$ref":"#/components/schemas/DtoEnvironmentGet"}},"additionalProperties":false},"DtoEnvironmentGet":{"required":["AgentGroups","InternalName"],"type":"object","properties":{"id":{"type":"integer","description":"Unique identifier for the Environment","format":"int64","readOnly":true},"displayName":{"type":"string","description":"Display name for the Environment","readOnly":true},"agentGroups":{"type":"array","items":{"$ref":"#/components/schemas/DtoAgentGroupGet"},"description":"The Agent Groups that belong to the Environment","readOnly":true},"internalName":{"type":"string","description":"Internal name used by Frends for the Environment","readOnly":true}},"additionalProperties":false},"DtoAgentGroupGet":{"required":["Agents","Environment","InternalName","IsCrossPlatform"],"type":"object","properties":{"id":{"type":"integer","description":"Unique identifier for the Agent Group","format":"int64","readOnly":true},"displayName":{"type":"string","description":"Display name for the Agent Group","readOnly":true},"internalName":{"type":"string","description":"Internal name used by Frends for the Agent Group","readOnly":true},"isCrossPlatform":{"type":"boolean","description":"Indicates whether the Agents in the group can be installed on Windows and Linux machines","readOnly":true},"agents":{"type":"array","items":{"type":"string"},"description":"The Agents that belong to the Agent Group","readOnly":true},"environment":{"$ref":"#/components/schemas/DtoEnvironmentBase"},"agentDetails":{"type":"array","items":{"$ref":"#/components/schemas/DtoAgentGet"},"description":"Details about the Agents that belong to the Agent Group","readOnly":true}},"additionalProperties":false},"DtoEnvironmentBase":{"required":["DisplayName","Id"],"type":"object","properties":{"id":{"type":"integer","description":"Unique identifier for the Environment","format":"int64","readOnly":true},"displayName":{"type":"string","description":"Display name for the Environment","readOnly":true}},"additionalProperties":false},"DtoAgentGet":{"required":["IsCloudAgent","IsGateway","Name"],"type":"object","properties":{"url":{"type":"string","description":"The hostname or address for the agent. Can either be full URL https://example.org:1234 or hostname subdomain.example.org","readOnly":true},"httpPorts":{"type":"array","items":{"type":"string"},"description":"List of http ports the Agent listens to. If the Url is a full address (schema://hostname:port?) this can be ignored.","readOnly":true},"httpsPorts":{"type":"array","items":{"type":"string"},"description":"List of https ports the Agent listens to. If the Url is a full address (schema://hostname:port?) this can be ignored.","readOnly":true},"id":{"type":"integer","description":"Agent Identifier","format":"int64"},"name":{"type":"string","description":"Agent name","readOnly":true},"isGateway":{"type":"boolean","description":"If the agent is a Gateway Agent. If true, these Agents are the ones that should primarily be accessible from the internet.","readOnly":true},"isCloudAgent":{"type":"boolean","description":"If the agent is a Cloud Agent. If true, these Agents are managed by Frends.","readOnly":true}},"additionalProperties":false}}}}
```

## The DtoEnvironmentVariableDescriptionUpdate object

```json
{"openapi":"3.0.1","info":{"title":"Frends API","version":"1.0"},"components":{"schemas":{"DtoEnvironmentVariableDescriptionUpdate":{"required":["Description"],"type":"object","properties":{"description":{"minLength":1,"type":"string"}},"additionalProperties":false,"description":"New description."}}}}
```

## The DtoEnvironmentVariableSchemaBase object

```json
{"openapi":"3.0.1","info":{"title":"Frends API","version":"1.0"},"components":{"schemas":{"DtoEnvironmentVariableSchemaBase":{"type":"object","properties":{"id":{"type":"integer","format":"int64"},"name":{"type":"string"},"type":{"$ref":"#/components/schemas/EnvironmentVariableType"},"values":{"type":"array","items":{"$ref":"#/components/schemas/DtoEnvironmentVariableValue"},"nullable":true}},"additionalProperties":false},"EnvironmentVariableType":{"enum":["String","Object","Array","Secret","Number","Boolean"],"type":"string"},"DtoEnvironmentVariableValue":{"type":"object","properties":{"value":{"type":"array","items":{"$ref":"#/components/schemas/JToken"}},"modifiedUtc":{"type":"string","format":"date-time"},"modifier":{"type":"string"},"version":{"type":"integer","format":"int32"},"environment":{"$ref":"#/components/schemas/DtoEnvironmentBase"}},"additionalProperties":false},"JToken":{"type":"array","items":{"$ref":"#/components/schemas/JToken"}},"DtoEnvironmentBase":{"required":["DisplayName","Id"],"type":"object","properties":{"id":{"type":"integer","description":"Unique identifier for the Environment","format":"int64","readOnly":true},"displayName":{"type":"string","description":"Display name for the Environment","readOnly":true}},"additionalProperties":false}}}}
```

## The DtoEnvironmentVariableSchemaGet object

```json
{"openapi":"3.0.1","info":{"title":"Frends API","version":"1.0"},"components":{"schemas":{"DtoEnvironmentVariableSchemaGet":{"type":"object","properties":{"id":{"type":"integer","format":"int64"},"name":{"type":"string"},"type":{"$ref":"#/components/schemas/EnvironmentVariableType"},"values":{"type":"array","items":{"$ref":"#/components/schemas/DtoEnvironmentVariableValue"},"nullable":true},"description":{},"childSchemas":{"type":"array","items":{"$ref":"#/components/schemas/DtoEnvironmentVariableSchemaBase"}}},"additionalProperties":false},"EnvironmentVariableType":{"enum":["String","Object","Array","Secret","Number","Boolean"],"type":"string"},"DtoEnvironmentVariableValue":{"type":"object","properties":{"value":{"type":"array","items":{"$ref":"#/components/schemas/JToken"}},"modifiedUtc":{"type":"string","format":"date-time"},"modifier":{"type":"string"},"version":{"type":"integer","format":"int32"},"environment":{"$ref":"#/components/schemas/DtoEnvironmentBase"}},"additionalProperties":false},"JToken":{"type":"array","items":{"$ref":"#/components/schemas/JToken"}},"DtoEnvironmentBase":{"required":["DisplayName","Id"],"type":"object","properties":{"id":{"type":"integer","description":"Unique identifier for the Environment","format":"int64","readOnly":true},"displayName":{"type":"string","description":"Display name for the Environment","readOnly":true}},"additionalProperties":false},"DtoEnvironmentVariableSchemaBase":{"type":"object","properties":{"id":{"type":"integer","format":"int64"},"name":{"type":"string"},"type":{"$ref":"#/components/schemas/EnvironmentVariableType"},"values":{"type":"array","items":{"$ref":"#/components/schemas/DtoEnvironmentVariableValue"},"nullable":true}},"additionalProperties":false}}}}
```

## The DtoEnvironmentVariableSchemaGetPagedResponse object

```json
{"openapi":"3.0.1","info":{"title":"Frends API","version":"1.0"},"components":{"schemas":{"DtoEnvironmentVariableSchemaGetPagedResponse":{"required":["Data","Paging"],"type":"object","properties":{"data":{"type":"array","items":{"$ref":"#/components/schemas/DtoEnvironmentVariableSchemaGet"},"description":"Response data"},"paging":{"$ref":"#/components/schemas/PagingModel"}},"additionalProperties":false},"DtoEnvironmentVariableSchemaGet":{"type":"object","properties":{"id":{"type":"integer","format":"int64"},"name":{"type":"string"},"type":{"$ref":"#/components/schemas/EnvironmentVariableType"},"values":{"type":"array","items":{"$ref":"#/components/schemas/DtoEnvironmentVariableValue"},"nullable":true},"description":{},"childSchemas":{"type":"array","items":{"$ref":"#/components/schemas/DtoEnvironmentVariableSchemaBase"}}},"additionalProperties":false},"EnvironmentVariableType":{"enum":["String","Object","Array","Secret","Number","Boolean"],"type":"string"},"DtoEnvironmentVariableValue":{"type":"object","properties":{"value":{"type":"array","items":{"$ref":"#/components/schemas/JToken"}},"modifiedUtc":{"type":"string","format":"date-time"},"modifier":{"type":"string"},"version":{"type":"integer","format":"int32"},"environment":{"$ref":"#/components/schemas/DtoEnvironmentBase"}},"additionalProperties":false},"JToken":{"type":"array","items":{"$ref":"#/components/schemas/JToken"}},"DtoEnvironmentBase":{"required":["DisplayName","Id"],"type":"object","properties":{"id":{"type":"integer","description":"Unique identifier for the Environment","format":"int64","readOnly":true},"displayName":{"type":"string","description":"Display name for the Environment","readOnly":true}},"additionalProperties":false},"DtoEnvironmentVariableSchemaBase":{"type":"object","properties":{"id":{"type":"integer","format":"int64"},"name":{"type":"string"},"type":{"$ref":"#/components/schemas/EnvironmentVariableType"},"values":{"type":"array","items":{"$ref":"#/components/schemas/DtoEnvironmentVariableValue"},"nullable":true}},"additionalProperties":false},"PagingModel":{"required":["CurrentPage","FirstPage","LastPage","PageSize","TotalCount"],"type":"object","properties":{"currentPage":{"type":"integer","description":"Current page","format":"int32"},"pageSize":{"type":"integer","description":"Number of entries per page","format":"int32"},"totalCount":{"type":"integer","description":"Total number of entries","format":"int32"},"firstPage":{"type":"string","description":"Url of the first page","format":"uri","nullable":true},"lastPage":{"type":"string","description":"Url of the last page","format":"uri","nullable":true},"nextPage":{"type":"string","description":"Url of the next page","format":"uri","nullable":true},"previousPage":{"type":"string","description":"Url of the previous page","format":"uri","nullable":true}},"additionalProperties":false}}}}
```

## The DtoEnvironmentVariableSchemaGetResponse object

```json
{"openapi":"3.0.1","info":{"title":"Frends API","version":"1.0"},"components":{"schemas":{"DtoEnvironmentVariableSchemaGetResponse":{"required":["Data"],"type":"object","properties":{"data":{"$ref":"#/components/schemas/DtoEnvironmentVariableSchemaGet"}},"additionalProperties":false},"DtoEnvironmentVariableSchemaGet":{"type":"object","properties":{"id":{"type":"integer","format":"int64"},"name":{"type":"string"},"type":{"$ref":"#/components/schemas/EnvironmentVariableType"},"values":{"type":"array","items":{"$ref":"#/components/schemas/DtoEnvironmentVariableValue"},"nullable":true},"description":{},"childSchemas":{"type":"array","items":{"$ref":"#/components/schemas/DtoEnvironmentVariableSchemaBase"}}},"additionalProperties":false},"EnvironmentVariableType":{"enum":["String","Object","Array","Secret","Number","Boolean"],"type":"string"},"DtoEnvironmentVariableValue":{"type":"object","properties":{"value":{"type":"array","items":{"$ref":"#/components/schemas/JToken"}},"modifiedUtc":{"type":"string","format":"date-time"},"modifier":{"type":"string"},"version":{"type":"integer","format":"int32"},"environment":{"$ref":"#/components/schemas/DtoEnvironmentBase"}},"additionalProperties":false},"JToken":{"type":"array","items":{"$ref":"#/components/schemas/JToken"}},"DtoEnvironmentBase":{"required":["DisplayName","Id"],"type":"object","properties":{"id":{"type":"integer","description":"Unique identifier for the Environment","format":"int64","readOnly":true},"displayName":{"type":"string","description":"Display name for the Environment","readOnly":true}},"additionalProperties":false},"DtoEnvironmentVariableSchemaBase":{"type":"object","properties":{"id":{"type":"integer","format":"int64"},"name":{"type":"string"},"type":{"$ref":"#/components/schemas/EnvironmentVariableType"},"values":{"type":"array","items":{"$ref":"#/components/schemas/DtoEnvironmentVariableValue"},"nullable":true}},"additionalProperties":false}}}}
```

## The DtoEnvironmentVariableValue object

```json
[...]
